TagLib::FLAC::File Class Reference

An implementation of TagLib::File with FLAC specific methods. More...

`#include <flacfile.h>`

Inheritance diagram for TagLib::FLAC::File:
[legend]
Collaboration diagram for TagLib::FLAC::File:
[legend]

## Public Types

enum | TagTypes { NoTags = 0x0000 , XiphComment = 0x0001 , ID3v1 = 0x0002 , ID3v2 = 0x0004 , AllTags = 0xffff }
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }

## Public Member Functions

| File (FileName file, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average, ID3v2::FrameFactory *frameFactory=nullptr)
TAGLIB_DEPRECATED | File (FileName file, ID3v2::FrameFactory *frameFactory, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average)
| File (IOStream *stream, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average, ID3v2::FrameFactory *frameFactory=nullptr)
TAGLIB_DEPRECATED | File (IOStream *stream, ID3v2::FrameFactory *frameFactory, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average)
| ~File () override
| File (const File &)=delete
File & | operator= (const File &)=delete
TagLib::Tag * | tag () const override
PropertyMap | properties () const override
void | removeUnsupportedProperties (const StringList &) override
PropertyMap | setProperties (const PropertyMap &) override
StringList | complexPropertyKeys () const override
List< VariantMap > | complexProperties (const String &key) const override
bool | setComplexProperties (const String &key, const List< VariantMap > &value) override
Properties * | audioProperties () const override
bool | save () override
ID3v2::Tag * | ID3v2Tag (bool create=false)
ID3v1::Tag * | ID3v1Tag (bool create=false)
Ogg::XiphComment * | xiphComment (bool create=false)
List< Picture * > | pictureList ()
void | removePicture (Picture *picture, bool del=true)
void | removePictures ()
void | addPicture (Picture *picture)
void | strip (int tags=AllTags)
bool | hasXiphComment () const
bool | hasID3v1Tag () const
bool | hasID3v2Tag () const
Public Member Functions inherited from TagLib::File
| File (const File &)=delete
File & | operator= (const File &)=delete
FileName | name () const
ByteVector | readBlock (size_t length)
void | writeBlock (const ByteVector &data)
offset_t | find (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
offset_t | rfind (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, offset_t start=0, size_t replace=0)
void | removeBlock (offset_t start=0, size_t length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (offset_t offset, Position p=Beginning)
void | clear ()
offset_t | tell () const
offset_t | length ()

## Static Public Member Functions

static bool | isSupported (IOStream *stream)

## Additional Inherited Members

Protected Member Functions inherited from TagLib::File
| File (FileName fileName)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (offset_t length)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An implementation of TagLib::File with FLAC specific methods.

This implements and provides an interface for FLAC files to the TagLib::Tag and TagLib::AudioProperties interfaces by way of implementing the abstract TagLib::File API as well as providing some additional information specific to FLAC files.

## Member Enumeration Documentation

## TagTypes

enum TagLib::FLAC::File::TagTypes

This set of flags is used for various operations and is suitable for being OR-ed together.

Enumerator
NoTags | Empty set. Matches no tag types.
XiphComment | Matches Vorbis comments.
ID3v1 | Matches ID3v1 tags.
ID3v2 | Matches ID3v2 tags.
AllTags | Matches all tag types.

## Constructor & Destructor Documentation

## File() [1/5]

TagLib::FLAC::File::File | ( | FileName | file,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | propertiesStyle = Properties::Average,
|  | ID3v2::FrameFactory * | frameFactory = nullptr )

Constructs a FLAC file from file. If readProperties is `true` the file's audio properties will also be read.

Note
  In the current implementation, propertiesStyle is ignored.

If this file contains an ID3v2 tag, the frames will be created using frameFactory (default if null).

References TagLib::AudioProperties::Average, and TAGLIB_DEPRECATED.

Referenced by File(), and operator=().

## File() [2/5]

TAGLIB_DEPRECATED TagLib::FLAC::File::File | ( | FileName | file,
|  | ID3v2::FrameFactory * | frameFactory,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | propertiesStyle = Properties::Average )

Constructs a FLAC file from file. If readProperties is `true` the file's audio properties will also be read.

If this file contains an ID3v2 tag, the frames will be created using frameFactory.

Note
  In the current implementation, propertiesStyle is ignored.

Deprecated
  Use the constructor above.

References TagLib::AudioProperties::Average.

## File() [3/5]

TagLib::FLAC::File::File | ( | IOStream * | stream,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | propertiesStyle = Properties::Average,
|  | ID3v2::FrameFactory * | frameFactory = nullptr )

Constructs a FLAC file from stream. If readProperties is `true` the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.

If this file contains an ID3v2 tag, the frames will be created using frameFactory (default if null).

Note
  In the current implementation, propertiesStyle is ignored.

References TagLib::AudioProperties::Average, and TAGLIB_DEPRECATED.

## File() [4/5]

TAGLIB_DEPRECATED TagLib::FLAC::File::File | ( | IOStream * | stream,
|  | ID3v2::FrameFactory * | frameFactory,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | propertiesStyle = Properties::Average )

Constructs a FLAC file from stream. If readProperties is `true` the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.

If this file contains an ID3v2 tag, the frames will be created using frameFactory.

Note
  In the current implementation, propertiesStyle is ignored.

Deprecated
  Use the constructor above.

References TagLib::AudioProperties::Average.

## ~File()

TagLib::FLAC::File::~File | ( |  | ) |

override virtual

Destroys this instance of the File.

Reimplemented from TagLib::File.

## File() [5/5]

TagLib::FLAC::File::File | ( | const File & |  | ) |

delete

References File().

## Member Function Documentation

## addPicture()

void TagLib::FLAC::File::addPicture | ( | Picture * | picture | ) |

Add a new picture to the file. The file takes ownership of the picture and will handle freeing its memory.

Note
  The file will be saved only after calling save().

## audioProperties()

Properties * TagLib::FLAC::File::audioProperties | ( |  | ) | const

override virtual

Returns the FLAC::Properties for this file. If no audio properties were read then this will return a null pointer.

Implements TagLib::File.

## complexProperties()

List< VariantMap > TagLib::FLAC::File::complexProperties | ( | const String & | key | ) | const

override virtual

Get the pictures stored in METADATA_BLOCK_PICTURE as complex properties for key "PICTURE".

Reimplemented from TagLib::File.

## complexPropertyKeys()

StringList TagLib::FLAC::File::complexPropertyKeys | ( |  | ) | const

override virtual

Returns ["PICTURE"] if any picture is stored in METADATA_BLOCK_PICTURE.

Reimplemented from TagLib::File.

## hasID3v1Tag()

bool TagLib::FLAC::File::hasID3v1Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an ID3v1 tag.

See also
  ID3v1Tag()

## hasID3v2Tag()

bool TagLib::FLAC::File::hasID3v2Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an ID3v2 tag.

See also
  ID3v2Tag()

## hasXiphComment()

bool TagLib::FLAC::File::hasXiphComment | ( |  | ) | const

Returns whether or not the file on disk actually has a XiphComment.

See also
  xiphComment()

## ID3v1Tag()

ID3v1::Tag * TagLib::FLAC::File::ID3v1Tag | ( | bool | create = false | ) |

Returns a pointer to the ID3v1 tag of the file.

If create is `false` (the default) this returns a null pointer if there is no valid APE tag. If create is `true` it will create an APE tag if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has an ID3v1 tag. Use hasID3v1Tag() to check if the file on disk actually has an ID3v1 tag.
  The Tag is still owned by the FLAC::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasID3v1Tag()

## ID3v2Tag()

ID3v2::Tag * TagLib::FLAC::File::ID3v2Tag | ( | bool | create = false | ) |

Returns a pointer to the ID3v2 tag of the file.

If create is `false` (the default) this returns a null pointer if there is no valid ID3v2 tag. If create is `true` it will create an ID3v2 tag if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has an ID3v2 tag. Use hasID3v2Tag() to check if the file on disk actually has an ID3v2 tag.
  The Tag is still owned by the FLAC::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasID3v2Tag()

## isSupported()

bool TagLib::FLAC::File::isSupported | ( | IOStream * | stream | ) |

static

Returns whether or not the given stream can be opened as a FLAC file.

Note
  This method is designed to do a quick check. The result may not necessarily be correct.

References TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## operator=()

File & TagLib::FLAC::File::operator= | ( | const File & |  | ) |

delete

References File().

## pictureList()

List< Picture * > TagLib::FLAC::File::pictureList | ( |  | ) |

Returns a list of pictures attached to the FLAC file.

## properties()

PropertyMap TagLib::FLAC::File::properties | ( |  | ) | const

override virtual

Implements the unified property interface – export function. If the file contains more than one tag (e.g. XiphComment and ID3v1), only the first one (in the order XiphComment, ID3v2, ID3v1) will be converted to the PropertyMap.

Reimplemented from TagLib::File.

## removePicture()

void TagLib::FLAC::File::removePicture | ( | Picture * | picture,
|  | bool | del = true )

Removes an attached picture. If del is `true` the picture's memory will be freed; if it is `false`, it must be deleted by the user.

## removePictures()

void TagLib::FLAC::File::removePictures | ( |  | ) |

Remove all attached images.

## removeUnsupportedProperties()

void TagLib::FLAC::File::removeUnsupportedProperties | ( | const StringList & | properties | ) |

override virtual

Removes unsupported properties, or a subset of them, from the file's metadata. The parameter properties must contain only entries from properties().unsupportedData().

Reimplemented from TagLib::File.

## save()

bool TagLib::FLAC::File::save | ( |  | ) |

override virtual

Save the file. This will primarily save the XiphComment, but will also keep any old ID3-tags up to date. If the file has no XiphComment, one will be constructed from the ID3-tags.

This returns `true` if the save was successful.

Implements TagLib::File.

## setComplexProperties()

bool TagLib::FLAC::File::setComplexProperties | ( | const String & | key,
|  | const List< VariantMap > & | value )

override virtual

Set the complex properties value as pictures in METADATA_BLOCK_PICTURE for key "PICTURE".

Reimplemented from TagLib::File.

## setProperties()

PropertyMap TagLib::FLAC::File::setProperties | ( | const PropertyMap & |  | ) |

override virtual

Implements the unified property interface – import function. This always creates a Xiph comment, if none exists. The return value relates to the Xiph comment only. Ignores any changes to ID3v1 or ID3v2 comments since they are not allowed in the FLAC specification.

Reimplemented from TagLib::File.

## strip()

void TagLib::FLAC::File::strip | ( | int | tags = AllTags | ) |

This will remove the tags that match the OR-ed together TagTypes from the file. By default it removes all tags.

Warning
  This will also invalidate pointers to the tags as their memory will be freed.

Note
  In order to make the removal permanent save() still needs to be called.
  This won't remove the Vorbis comment block completely. The vendor ID will be preserved.

References AllTags.

## tag()

TagLib::Tag * TagLib::FLAC::File::tag | ( |  | ) | const

override virtual

Returns the Tag for this file. This will be a union of XiphComment, ID3v1 and ID3v2 tags.

See also
  ID3v2Tag()
  ID3v1Tag()
  XiphComment()

Implements TagLib::File.

## xiphComment()

Ogg::XiphComment * TagLib::FLAC::File::xiphComment | ( | bool | create = false | ) |

Returns a pointer to the XiphComment for the file.

If create is `false` (the default) this returns a null pointer if there is no valid XiphComment. If create is `true` it will create a XiphComment if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has a XiphComment. Use hasXiphComment() to check if the file on disk actually has a XiphComment.
  The Tag is still owned by the FLAC::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasXiphComment()

The documentation for this class was generated from the following file:

- flacfile.h